//+------------------------------------------------------------------+
//|                                         Indicator: fisherRSX.mq4 |
//|                                       Created with EABuilder.com |
//|                                             http://eabuilder.com |
//+------------------------------------------------------------------+
#property copyright "Created with EABuilder.com"
#property link      "http://eabuilder.com"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 2

#property indicator_type1 DRAW_ARROW
#property indicator_width1 2
#property indicator_color1 0x0000FF
#property indicator_label1 "Buy"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 2
#property indicator_color2 0x0000FF
#property indicator_label2 "Sell"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | fisherRSX @ "+Symbol()+","+Period()+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, 0);
   SetIndexArrow(0, 251);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, 0);
   SetIndexArrow(1, 251);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, 0);
      ArrayInitialize(Buffer2, 0);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      //Indicator Buffer 1
      if(iCustom(NULL, PERIOD_CURRENT, "NonLag Inverse fisher transform of RSX", 5, 15, 0.90, 0.0, -0.90, true, 1, i) > 0 //NonLag Inverse fisher transform of RSX > fixed value
      && iCustom(NULL, PERIOD_CURRENT, "Fisher_Yur4ik_2", 10, 0, i) > 0 //Fisher_Yur4ik_2 > fixed value
      && iCustom(NULL, PERIOD_CURRENT, "ZeroLAG_MA", 96, 0, 1, 0, 96, 0, 1, 0, i) < iCustom(NULL, PERIOD_CURRENT, "TMA+CG mladen", "current time frame", 56, PRICE_WEIGHTED, 1.618, true, false, false, false, false, false, false, false, 0, i) //ZeroLAG_MA < TMA+CG mladen
      && Close[1+i] < iCustom(NULL, PERIOD_CURRENT, "TMA+CG mladen", "current time frame", 56, PRICE_WEIGHTED, 1.618, true, false, false, false, false, false, false, false, 2, i) //Candlestick Close < TMA+CG mladen
      )
        {
         Buffer1[i] = Low[i]; //Set indicator value at Candlestick Low
        }
      else
        {
         Buffer1[i] = 0;
        }
      //Indicator Buffer 2
      if(iCustom(NULL, PERIOD_CURRENT, "NonLag Inverse fisher transform of RSX", 5, 15, 0.90, 0.0, -0.90, true, 3, i) > 0 //NonLag Inverse fisher transform of RSX > fixed value
      && iCustom(NULL, PERIOD_CURRENT, "Fisher_Yur4ik_2", 10, 0, i) < 0 //Fisher_Yur4ik_2 < fixed value
      && iCustom(NULL, PERIOD_CURRENT, "ZeroLAG_MA", 96, 0, 1, 0, 96, 0, 1, 0, i) > iCustom(NULL, PERIOD_CURRENT, "TMA+CG mladen", "current time frame", 56, PRICE_WEIGHTED, 1.618, true, false, false, false, false, false, false, false, 0, i) //ZeroLAG_MA > TMA+CG mladen
      && Close[1+i] > iCustom(NULL, PERIOD_CURRENT, "TMA+CG mladen", "current time frame", 56, PRICE_WEIGHTED, 1.618, true, false, false, false, false, false, false, false, 1, i) //Candlestick Close > TMA+CG mladen
      )
        {
         Buffer2[i] = High[i]; //Set indicator value at Candlestick High
        }
      else
        {
         Buffer2[i] = 0;
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+